Dedicated Engine Schema
An engine schema is an object which describes what fields are available in the engine. Do not confuse engine schema with Schema.
Talk with a Rossum representative about enabling this feature. You can create new Dedicated Engine objects. However, no Dedicated Engine will be trained unless Dedicated Engines are part of your agreement.
Schema can be edited only if its Dedicated Engine has status draft.
Dedicated engine schema
ID of the engine schema.
URL of the engine schema.
List dedicated engine schemas
GET api / v1 / dedicated_engine_schemas
Retrieve all dedicated engine schema objects.
Please note that Dedicated Engine Schema is an internal API and can be changed without notice.
curl -X GET "https://example.rossum.app/api/v1/dedicated_engine_schemas"{
"pagination": {
"next": null,
"previous": null
},
"results": [
{
"id": 6000,
"url": "https://example.rossum.app/api/v1/dedicated_engine_schemas/6000",
"content": {
"training_queues": [
"https://example.rossum.app/api/v1/queues/123",
"https://example.rossum.app/api/v1/queues/200",
"https://example.rossum.app/api/v1/queues/321"
],
"fields": [
{
"category": "multivalue",
"engine_output_id": "line_items",
"label": "Line Items",
"trained": true,
"type": "grid",
"description": "Line item column types.",
"children": {
"category": "tuple",
"children": [
{
"category": "datapoint",
"engine_output_id": "document_id",
"label": "Document ID",
"trained": true,
"type": "string",
"description": "Document number",
"sources": [
{
"queue": "string",
"schema_id": "document_id"
}
]
}
]
}
}
]
}
}
]
}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Response
OK
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Create dedicated engine schema
POST api / v1 / dedicated_engine_schemas
Create a new dedicated engine schema object.
curl -X POST "https://example.rossum.app/api/v1/dedicated_engine_schemas" \ -H "Content-Type: application/json" \ -d '{ "content": {} }'{
"id": 6000,
"url": "https://example.rossum.app/api/v1/dedicated_engine_schemas/6000",
"content": {
"training_queues": [
"https://example.rossum.app/api/v1/queues/123",
"https://example.rossum.app/api/v1/queues/200",
"https://example.rossum.app/api/v1/queues/321"
],
"fields": [
{
"category": "multivalue",
"engine_output_id": "line_items",
"label": "Line Items",
"trained": true,
"type": "grid",
"description": "Line item column types.",
"children": {
"category": "tuple",
"children": [
{
"category": "datapoint",
"engine_output_id": "document_id",
"label": "Document ID",
"trained": true,
"type": "string",
"description": "Document number",
"sources": [
{
"queue": "string",
"schema_id": "document_id"
}
]
}
]
}
}
]
}
}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Payload Too Large.",
"code": "payload_too_large"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Request Body
application/json
Response
Created
ID of the engine schema.
URL of the engine schema.
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Payload too large (especially for files uploaded).
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Retrieve dedicated engine schema
GET api / v1 / dedicated_engine_schemas / {dedicatedEngineSchemaID}
Get a dedicated engine schema object.
curl -X GET "https://example.rossum.app/api/v1/dedicated_engine_schemas/0"{
"id": 6000,
"url": "https://example.rossum.app/api/v1/dedicated_engine_schemas/6000",
"content": {
"training_queues": [
"https://example.rossum.app/api/v1/queues/123",
"https://example.rossum.app/api/v1/queues/200",
"https://example.rossum.app/api/v1/queues/321"
],
"fields": [
{
"category": "multivalue",
"engine_output_id": "line_items",
"label": "Line Items",
"trained": true,
"type": "grid",
"description": "Line item column types.",
"children": {
"category": "tuple",
"children": [
{
"category": "datapoint",
"engine_output_id": "document_id",
"label": "Document ID",
"trained": true,
"type": "string",
"description": "Document number",
"sources": [
{
"queue": "string",
"schema_id": "document_id"
}
]
}
]
}
}
]
}
}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Response
OK
ID of the engine schema.
URL of the engine schema.
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Partial update dedicated engine schema
PATCH api / v1 / dedicated_engine_schemas / {dedicatedEngineSchemaID}
Update part of a dedicated engine schema object.
Please note that Dedicated Engine Schema is an internal API and can be changed without notice.
curl -X PATCH "https://example.rossum.app/api/v1/dedicated_engine_schemas/0" \ -H "Content-Type: application/json" \ -d '{}'{
"id": 6000,
"url": "https://example.rossum.app/api/v1/dedicated_engine_schemas/6000",
"content": {
"training_queues": [
"https://example.rossum.app/api/v1/queues/123",
"https://example.rossum.app/api/v1/queues/200",
"https://example.rossum.app/api/v1/queues/321"
],
"fields": [
{
"category": "multivalue",
"engine_output_id": "line_items",
"label": "Line Items",
"trained": true,
"type": "grid",
"description": "Line item column types.",
"children": {
"category": "tuple",
"children": [
{
"category": "datapoint",
"engine_output_id": "document_id",
"label": "Document ID",
"trained": true,
"type": "string",
"description": "Document number",
"sources": [
{
"queue": "string",
"schema_id": "document_id"
}
]
}
]
}
}
]
}
}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Payload Too Large.",
"code": "payload_too_large"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Request Body
application/json
Response
OK
ID of the engine schema.
URL of the engine schema.
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Payload too large (especially for files uploaded).
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Delete dedicated engine schema
DELETE api / v1 / dedicated_engine_schemas / {dedicatedEngineSchemaID}
Delete a dedicated engine schema object.
Please note that Dedicated Engine Schema is an internal API and can be changed without notice.
curl -X DELETE "https://example.rossum.app/api/v1/dedicated_engine_schemas/0"{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Response
No Content
No response body.
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Update dedicated engine schema
PUT api / v1 / dedicated_engine_schemas / {dedicatedEngineSchemaID}
Update dedicated engine schema object.
Please note that Dedicated Engine Schema is an internal API and can be changed without notice.
curl -X PUT "https://example.rossum.app/api/v1/dedicated_engine_schemas/0" \ -H "Content-Type: application/json" \ -d '{ "content": {} }'{
"id": 6000,
"url": "https://example.rossum.app/api/v1/dedicated_engine_schemas/6000",
"content": {
"training_queues": [
"https://example.rossum.app/api/v1/queues/123",
"https://example.rossum.app/api/v1/queues/200",
"https://example.rossum.app/api/v1/queues/321"
],
"fields": [
{
"category": "multivalue",
"engine_output_id": "line_items",
"label": "Line Items",
"trained": true,
"type": "grid",
"description": "Line item column types.",
"children": {
"category": "tuple",
"children": [
{
"category": "datapoint",
"engine_output_id": "document_id",
"label": "Document ID",
"trained": true,
"type": "string",
"description": "Document number",
"sources": [
{
"queue": "string",
"schema_id": "document_id"
}
]
}
]
}
}
]
}
}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Payload Too Large.",
"code": "payload_too_large"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Request Body
application/json
Response
OK
ID of the engine schema.
URL of the engine schema.
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Payload too large (especially for files uploaded).
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Predict dedicated engine schema
POST api / v1 / dedicated_engine_schemas / predict
Try to predict a dedicated engine schema based on the provided training queue's schemas. The predicted schema is not guaranteed to pass /v1/dedicated_engine_schemas/validate check, only the checks done on engine schema save.
Returns 200 and predicted dedicated engine schema.
curl -X POST "https://example.rossum.app/api/v1/dedicated_engine_schemas/predict" \ -H "Content-Type: application/json" \ -d '{ "training_queues": [ "https://example.rossum.app/api/v1/queues/123", "https://example.rossum.app/api/v1/queues/200", "https://example.rossum.app/api/v1/queues/321" ] }'{
"content": {
"training_queues": [
"https://example.rossum.app/api/v1/queues/123",
"https://example.rossum.app/api/v1/queues/200",
"https://example.rossum.app/api/v1/queues/321"
],
"fields": [
{
"category": "multivalue",
"engine_output_id": "line_items",
"label": "Line Items",
"trained": true,
"type": "grid",
"description": "Line item column types.",
"children": {
"category": "tuple",
"children": [
{
"category": "datapoint",
"engine_output_id": "document_id",
"label": "Document ID",
"trained": true,
"type": "string",
"description": "Document number",
"sources": [
{
"queue": "string",
"schema_id": "document_id"
}
]
}
]
}
}
]
}
}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Payload Too Large.",
"code": "payload_too_large"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Request Body
application/json
List of Queues that will be used for the training.
Response
Predicted dedicated engine schema
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Payload too large (especially for files uploaded).
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error
Validate dedicated engine schema
POST api / v1 / dedicated_engine_schemas / validate
Validate dedicated engine schema object, check for errors. Additionally, to the basic checks done by the CRUD endpoints, this endpoint checks that:
- The declared
engine_output_ids are unique across the whole schema - The mapped Queue datapoints (via
schema_ids) are of the same type as the declaredtype - The mapped Queue datapoints of
enumtype have exactly the same option values declared - Different shapes of datapoints are not mixed together
- The mapped Queue datapoints of Multivalue-Tuple fields are of the same
grid/freeformtype - When mapping to a single Multivalue-Tuple field, all the datapoints mapped from one Queue must come from a single tabular datapoint
- Multiple fields do not link to the same Queue Datapoint
- A mapped field either maps a Queue Datapoint with
null/emptyrir_field_namesor theengine_output_idmatches one of the mapped rir-namespacedrir_field_names(prefixed byrir:or nothing)
Returns 200 and error description in case of validation failure.
curl -X POST "https://example.rossum.app/api/v1/dedicated_engine_schemas/validate" \ -H "Content-Type: application/json" \ -d '{ "content": {} }'{}{
"detail": "Bad Request.",
"code": "bad_request"
}{
"detail": "Invalid token.",
"code": "authentication_failed"
}{
"detail": "Access to the requested resource is forbidden.",
"code": "access_forbidden"
}{
"detail": "Not found.",
"code": "not_found"
}{
"detail": "Conflict.",
"code": "conflict_status"
}{
"detail": "Payload Too Large.",
"code": "payload_too_large"
}{
"detail": "Request was rate limited.",
"code": "rate_limited",
"url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}{
"detail": "Server error.",
"code": "error"
}{
"detail": "Bad Gateway.",
"code": "bad_gateway"
}{
"detail": "Service Unavailable.",
"code": "service_unavailable"
}{
"detail": "Gateway timeout.",
"code": "gateway_timeout"
}Request Body
application/json
Response
Validation result (success or failure with error description)
responseobjectValidation result object
Invalid input data.
Detail of the error
Code of the error
The username/password is invalid or token is invalid (e.g. expired).
Detail of the error
Code of the error
Insufficient permission, missing authentication, invalid CSRF token and similar issue.
Detail of the error
Code of the error
The specified resource was not found.
Detail of the error
Code of the error
Conflict
Detail of the error
Code of the error
Payload too large (especially for files uploaded).
Detail of the error
Code of the error
Request rate is too high, wait before sending more requests. See Rate Limiting for more details.
Detail of the error
Code of the error
Link to the rate limiting documentation
Server failure while processing the request.
Detail of the error
Code of the error
Invalid response from the upstream server.
Detail of the error
Code of the error
We're temporarily offline for maintenance. Please try again later.
Detail of the error
Code of the error
Upstream server could not complete the request in time.
Detail of the error
Code of the error